<?php

    // First we execute our common code to connection to the database and start the session
    require($_SERVER["DOCUMENT_ROOT"]."/_libraries/login/common.php");

    /* Functions
    **************************************************** */
    include_once ($_SERVER["DOCUMENT_ROOT"]."/_libraries/functions.php");
    include_once ($_SERVER["DOCUMENT_ROOT"]."/_libraries/login/bootstrap.inc");
    include_once ($_SERVER["DOCUMENT_ROOT"]."/_libraries/login/password.inc");

 
    
    // This variable will be used to re-display the user's username to them in the
    // login form if they fail to enter the correct password.  It is initialized here
    // to an empty value, which will be shown if the user has not submitted the form.
    $submitted_username = '';
    // This if statement checks to determine whether the login form has been submitted
    // If it has, then the login code is run, otherwise the form is displayed
    if(!empty($_POST))
    {

        // This query retreives the user's information from the database using
        // their username.
            $query = '
            SELECT
               *
            FROM '.$GLOBALS['db_prefix'].'users
            
            WHERE
             
                email = :email
            AND 
                active = 1
            AND
                status = 1
        ';

        // The parameter values
        $query_params = array(
            'email' => $_POST['email']
        );

        try
        {
            // Execute the query against the database
            $stmt = $db->prepare($query);
            $result = $stmt->execute($query_params);
        }
        catch(PDOException $ex)
        {
            // Note: On a production website, you should not output $ex->getMessage().
            // It may provide an attacker with helpful information about your code.
           die("Failed to run query: " . $ex->getMessage());
            $smarty->assign( 'login_error', 'Failed to run query: ' . $ex->getMessage());
        }
        // This variable tells us whether the user has successfully logged in or not.
        // We initialize it to false, assuming they have not.
        // If we determine that they have entered the right details, then we switch it to true.
        $login_ok = false;
        
        // Retrieve the user data from the database.  If $row is false, then the username
        // they entered is not registered.
        $row = $stmt->fetch();
        if($row != false)
        {
 
            // Using the password submitted by the user and the salt stored in the database,
            // we now check to see whether the passwords match by hashing the submitted password
            // and comparing it to the hashed version already stored in the database.
            // $check_password = hash('sha256', $_POST['password'] . $row['salt']);
            
            $check_password = user_check_password($_REQUEST['password'],$row['password'] );
            if ($check_password){
                $login_ok = true;
            }
            // for($round = 0; $round < 65536; $round++)
            // {
            //     $check_password = hash('sha256', $check_password . $row['salt']);
            // }
            // if($check_password === $row['password'])
            // {
            //     // If they do, then we flip this to true
            //     $login_ok = true;
            // }
        }
        // If the user logged in successfully, then we send them to the private members-only page
        // Otherwise, we display a login failed message and show the login form again
        if($login_ok != false)
        {
            // Here I am preparing to store the $row array into the $_SESSION by
            // removing the salt and password values from it.  Although $_SESSION is
            // stored on the server-side, there is no reason to store sensitive values
            // in it unless you have to.  Thus, it is best practice to remove these
            // sensitive values first.
            //unset($row['salt']);
            unset($row['password']);

            
            //token
            $token = explode('.',setToken($row['id']));
            $row['token'] = $token[0];
            $row['tokenExpiration'] = $token[1];
            
            
            // Obligations 

            // This stores the user's data into the session at the index 'user'.
            // We will check this index on the private members-only page to determine whether
            // or not the user is logged in.  We can also use it to retrieve
            // the user's details.
            $_SESSION['user'] = $row;
            

            if(isset($row['obligations']) && !empty($row['obligations'])) {
                $_SESSION['user']['obligations_arr'] = json_decode($row['obligations'], true);
            }
            
            $gravatar = @get_gravatar($_SESSION['user']['email'],50);
            if ( isset($gravatar) && $gravatar !='') {
                $_SESSION['user']['gravatar'] = $gravatar;
            }
            $gravatarLarge = @get_gravatar($_SESSION['user']['email'],200);
            if ( isset($gravatarLarge) && $gravatarLarge !='') {
                $_SESSION['user']['gravatarLarge'] = $gravatarLarge;
            }
            
            
            // Insert login log into database
            if (isset($GLOBALS['mode_log_logins']) && $GLOBALS['mode_log_logins']==true) {
                try {
                    $data = $db->prepare('
                        INSERT INTO '.$GLOBALS['db_prefix'].'logs_login
                        ( user_id, ip, date_time,act)
                        VALUES (  :user_id, :ip, :date_time, 1)');
                    $data->execute(
                        array(
                            'user_id' => $_SESSION['user']['id'],
                            'ip' => getClientIP(),
                            'date_time' => $GLOBALS['current_date_time'],
                        )
                    );
                } catch(PDOException $e) { $errors[] = $e->getMessage();}
            }


            // Add activity
            @add_activity ('user_loggedin',$_SESSION['user']['email'], $_SESSION['user']['user_type']);

            
            // Redirect the user to the private members-only page.
            // if (isset($_REQUEST['redirect_to']) && $_REQUEST['redirect_to'] !='') {
                
            //     header("Location: ".$_REQUEST['redirect_to']."");
            //     die("Redirecting to: ".$_REQUEST['redirect_to']."");
                
            // } else {
            //     header("Location: ".$GLOBALS['loginRedirect']."");
            //     die("Redirecting to: ".$GLOBALS['loginRedirect']."");
            // }
        }
        else
        {
            // Tell the user they failed
            // $smarty->assign( 'login_error', $GLOBALS['admin_language']['MESSAGE_LOGIN_FAILED'] );
            $smarty->assign( 'login_error','The e-mail address or password you entered was incorrect.' );
            //print("Login Failed.");

            // Show them their username again so all they have to do is enter a new
            // password.  The use of htmlentities prevents XSS attacks.  You should
            // always use htmlentities on user submitted values before displaying them
            // to any users (including the user that submitted them).  For more information:
            // http://en.wikipedia.org/wiki/XSS_attack
            //$submitted_username = htmlentities($_POST['fullname'], ENT_QUOTES, 'UTF-8');
        }
    }

