<?php


/* ####################################  
   CORS                             
   #################################### */

    // * wont work in FF w/ Allow-Credentials
    //if you dont need Allow-Credentials, * seems to work
    header('Access-Control-Allow-Origin: *');
    //if you need cookies or login etc
    //header('Access-Control-Allow-Credentials: true');
    if ($_SERVER['REQUEST_METHOD'] == 'OPTIONS')
    {
      header('Access-Control-Allow-Methods: GET, POST, PUT, DELETE, OPTIONS');
      header('Access-Control-Max-Age: 604800');
      //if you need special headers
      header('Access-Control-Allow-Headers: x-requested-with');
      exit(0);
    }

/* ####################################  
   Includes                            
   #################################### */

    include ($_SERVER['DOCUMENT_ROOT'].'/_config/_config.php');


    if(isset($_REQUEST['instance']) && $_REQUEST['instance']!='') {

        include ($_SERVER['DOCUMENT_ROOT'].'/_config/_'.$_REQUEST['instance'].'_config.php');
    
    }


    include ($_SERVER['DOCUMENT_ROOT'].'/_libraries/functions.php');


/* ####################################  
   Content type                              
   #################################### */

    header('Content-Type: application/json');


    /**********************************  
        AUTH                            
    **********************************/

        // Check if user/password auth
        if ( isset($_REQUEST[$GLOBALS['aPiUsrNm']])   && $_REQUEST[$GLOBALS['aPiUsrNm']] != '' &&  isset($_REQUEST[$GLOBALS['aPiPswRd']]) && $_REQUEST[$GLOBALS['aPiPswRd']] !='' ) {
        
            
            if ( ($_REQUEST[$GLOBALS['aPiUsrNm']]!=$GLOBALS['aPiUsrNmVaLue']) and ($_REQUEST[$GLOBALS['aPiPswRd']]!=$GLOBALS['aPiPswRdVaLue'] ) ) {
            
                $errors[] = 'Authorization failed. Error code: 5203.';
                
            }
            
        } else if (isset($_REQUEST['api_key']) && $_REQUEST['api_key'] != '') {

            try {
                        /* Connection
                        **************************************************** */
                        $conn = new PDO("mysql:host=".$GLOBALS['db_host'].";dbname=".$GLOBALS['db_database'], $GLOBALS['db_user'], $GLOBALS['db_pass']);
                        $conn->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
                        $conn->setAttribute(PDO::ATTR_EMULATE_PREPARES, false);

                        /* Query
                        **************************************************** */
                        $query = 'SELECT api_key FROM '.$GLOBALS['db_prefix'].'system WHERE api_key = :api_key';
                        $data = $conn->prepare($query);
                        $data->execute(array('api_key' => $_REQUEST['api_key']));
                        $result = $data->fetch();

                        if ( count($result) > 0 ) {
                            
                            $api_key = $result['api_key'];

                                if ( $api_key != $_REQUEST['api_key']){

                                    $errors[] = 'Authorization failed. Error code: 5204.';

                                }
                            

                        } else {

                            $errors[] = 'Authorization failed. Error code: 5205.';

                        }

                    } catch(PDOException $e) { $errors[] = $e->getMessage();}


        } else {
            
                // Check if token auth

                if ( !isset($_REQUEST['token']) || $_REQUEST['token'] == '') {

                    $errors[] = 'Authorization failed. Error code: 5200.';

                } else {

                    try {
                        /* Connection
                        **************************************************** */
                        $conn = new PDO("mysql:host=".$GLOBALS['db_host'].";dbname=".$GLOBALS['db_database'], $GLOBALS['db_user'], $GLOBALS['db_pass']);
                        $conn->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
                        $conn->setAttribute(PDO::ATTR_EMULATE_PREPARES, false);

                        /* Query
                        **************************************************** */
                        $query = 'SELECT token,token_expire,id FROM users WHERE token = :token';
                        $data = $conn->prepare($query);
                        $data->execute(array('token' => $_REQUEST['token']));
                        $result = $data->fetchAll();

                        if ( count($result) > 0 ) {
                            foreach($result as $row) {

                                $tokenGeneric = $GLOBALS['SECRET_KEY'].$row['id']; // It can be 'stronger' of course
                                $token = hash('sha256', $tokenGeneric);

                                if ( $token != $_REQUEST['token']){

                                    $errors[] = 'Authorization failed. Error code: 5201.';

                                }
                            }

                        } else {

                            $errors[] = 'Authorization failed. Error code: 5203.';

                        }

                    } catch(PDOException $e) { $errors[] = $e->getMessage();}
                }
        
        }



 if ( isset($errors) ) { var_dump($errors); } 

else {



function date_compare2($a, $b)
{
    $t1 = strtotime($a['created_at']);
    $t2 = strtotime($b['created_at']);
    return $t2 - $t1;
}    



$GLOBALS['db_prefix'] = 'sdi9_';
$GLOBALS['db_database_accounts']  = 'eaglerecruiting_accounts';
$GLOBALS['db_host_accounts'] = '62.171.130.14';
$GLOBALS['db_user_accounts'] = 'eaglerecruiting_root';
$GLOBALS['db_pass_accounts'] = '4b,KjtHb%&@B';



try {
            /* Connection
            **************************************************** */
            $conn = new PDO("mysql:host=".$GLOBALS['db_host_accounts'].";dbname=".$GLOBALS['db_database_accounts'], $GLOBALS['db_user_accounts'], $GLOBALS['db_pass_accounts']);
            $conn->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
            $conn->setAttribute(PDO::ATTR_EMULATE_PREPARES, true);
            $conn->exec("set names utf8");
    
            /* Query
            **************************************************** */


      
          	$query = 'SELECT * FROM accounts WHERE approved="1"';
            $data = $conn->prepare($query);
            $data->execute();
            $result = $data->fetchAll();

            
            /* Total number of approved accounts
            ************************************************ */
            $acc_num = count($result);
          
            
            /* Make connections for all accounts
            ********************************************** */

            $conn_acc = [];

            for ($i = 0; $i < $acc_num; $i++) {
			 
				$conn_acc[$i] = new PDO("mysql:host=".$GLOBALS['db_host_accounts'].";dbname=".$result[$i]['db_name_recruiting'], $result[$i]['db_user'], $result[$i]['db_password']);
	            $conn_acc[$i] ->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
	            $conn_acc[$i] ->setAttribute(PDO::ATTR_EMULATE_PREPARES, true);
	            $conn_acc[$i] ->exec("set names utf8");

			}

			$query_main = [];
			$all_leads = [];
	        $item_arr = array();

			for ($i = 0; $i < $acc_num; $i++) { 
				
				$query_main[$i] = 'SELECT * FROM sdi9_leads WHERE active="1"';
				$data = $conn_acc[$i]->prepare($query_main[$i]);
	            $data->execute();

	            $result_main[$i] = $data->fetchAll(PDO::FETCH_ASSOC);	  

	            foreach ($result_main[$i] as $item) {

                    $diff=null;
                    if(isset($item['created_at']) && !empty($item['created_at'])) {

                        $today = date("Y-m-d");

                        $diff  = getDaysBetweenTwoDates($item['created_at'],$today);

                    } 

                    $item['diff'] = $diff;

	            	$item['db'] = $result[$i]['instance_slug'];
 	            
 	            	array_push($item_arr, $item);
 	            }

			}
				
			// var_dump($item_arr);
			usort($item_arr, 'date_compare2');
			
			$ctn = count($item_arr);
			$json_all = json_encode($item_arr, true);
			echo $json_all;

		

    } catch(PDOException $e) { $errors[] = $e->getMessage(); var_dump($errors);}


}