<?php

/**
 * Please note: we can use unencoded characters like ö, é etc here as we use the html5 doctype with utf8 encoding
 * in the application's header (in views/_header.php). To add new languages simply copy this file,
 * and create a language switch in your root files.
 */
$GLOBALS['admin_lang'] = $GLOBALS['lang'] = array(
 
    // login & registration classes
    "MESSAGE_ACCOUNT_NOT_ACTIVATED" => "Your account is not activated yet. Please click on the confirm link in the mail.",
    "MESSAGE_CAPTCHA_WRONG" => "Captcha was wrong!",
    "MESSAGE_COOKIE_INVALID" => "Invalid cookie",
    "MESSAGE_DATABASE_ERROR" => "Database connection problem.",
    "MESSAGE_EMAIL_ALREADY_EXISTS" => "This email address is already registered. Please use the \"I forgot my password\" page if you don't remember it.",
    "MESSAGE_EMAIL_CHANGE_FAILED" => "Sorry, your email changing failed.",
    "MESSAGE_EMAIL_CHANGED_SUCCESSFULLY" => "Your email address has been changed successfully. New email address is ",
    "MESSAGE_EMAIL_EMPTY" => "Email cannot be empty",
    "MESSAGE_EMAIL_INVALID" => "Your email address is not in a valid email format",
    "MESSAGE_EMAIL_SAME_LIKE_OLD_ONE" => "Sorry, that email address is the same as your current one. Please choose another one.",
    "MESSAGE_EMAIL_TOO_LONG" => "Email cannot be longer than 64 characters",
    "MESSAGE_LINK_PARAMETER_EMPTY" => "Empty link parameter data.",
    "MESSAGE_LOGGED_OUT" => "You have been logged out.",
    // The "login failed"-message is a security improved feedback that doesn't show a potential attacker if the user exists or not
    "MESSAGE_LOGIN_FAILED" => "Login failed.",
    "MESSAGE_OLD_PASSWORD_WRONG" => "Your OLD password was wrong.",
    "MESSAGE_PASSWORD_BAD_CONFIRM" => "Password and password repeat are not the same",
    "MESSAGE_PASSWORD_CHANGE_FAILED" => "Sorry, your password changing failed.",
    "MESSAGE_PASSWORD_CHANGED_SUCCESSFULLY" => "Password successfully changed!",
    "MESSAGE_PASSWORD_EMPTY" => "Password field was empty",
    "MESSAGE_PASSWORD_RESET_MAIL_FAILED" => "Password reset mail NOT successfully sent! Error: ",
    "MESSAGE_PASSWORD_RESET_MAIL_SUCCESSFULLY_SENT" => "Password reset mail successfully sent!",
    "MESSAGE_PASSWORD_TOO_SHORT" => "Password has a minimum length of 6 characters",
    "MESSAGE_PASSWORD_WRONG" => "Wrong password. Try again.",
    "MESSAGE_PASSWORD_WRONG_3_TIMES" => "You have entered an incorrect password 3 or more times already. Please wait 30 seconds to try again.",
    "MESSAGE_REGISTRATION_ACTIVATION_NOT_SUCCESSFUL" => "Sorry, no such id/verification code combination here...",
    "MESSAGE_REGISTRATION_ACTIVATION_SUCCESSFUL" => "Activation was successful! You can now log in!",
    "MESSAGE_REGISTRATION_FAILED" => "Sorry, your registration failed. Please go back and try again.",
    "MESSAGE_RESET_LINK_HAS_EXPIRED" => "Your reset link has expired. Please use the reset link within one hour.",
    "MESSAGE_VERIFICATION_MAIL_ERROR" => "Sorry, we could not send you an verification mail. Your account has NOT been created.",
    "MESSAGE_VERIFICATION_MAIL_NOT_SENT" => "Verification Mail NOT successfully sent! Error: ",
    "MESSAGE_VERIFICATION_MAIL_SENT" => "Your account has been created successfully and we have sent you an email. Please click the VERIFICATION LINK within that mail.",
    "MESSAGE_USER_DOES_NOT_EXIST" => "This user does not exist",
    "MESSAGE_USERNAME_BAD_LENGTH" => "Username cannot be shorter than 2 or longer than 64 characters",
    "MESSAGE_USERNAME_CHANGE_FAILED" => "Sorry, your chosen username renaming failed",
    "MESSAGE_USERNAME_CHANGED_SUCCESSFULLY" => "Your username has been changed successfully. New username is ",
    "MESSAGE_USERNAME_EMPTY" => "Username field was empty",
    "MESSAGE_USERNAME_EXISTS" => "Sorry, that username is already taken. Please choose another one.",
    "MESSAGE_USERNAME_INVALID" => "Username does not fit the name scheme: only a-Z and numbers are allowed, 2 to 64 characters",
    "MESSAGE_USERNAME_SAME_LIKE_OLD_ONE" => "Sorry, that username is the same as your current one. Please choose another one.",

    // views
    "WORDING_BACK_TO_LOGIN" => "Back to Login Page",
    "WORDING_CHANGE_EMAIL" => "Change email",
    "WORDING_CHANGE_PASSWORD" => "Change password",
    "WORDING_CHANGE_USERNAME" => "Change username",
    "WORDING_CURRENTLY" => "currently",
    "WORDING_EDIT_USER_DATA" => "Edit user data",
    "WORDING_EDIT_YOUR_CREDENTIALS" => "You are logged in and can edit your credentials here",
    "WORDING_FORGOT_MY_PASSWORD" => "I forgot my password",
    "WORDING_LOGIN" => "Log in",
    "WORDING_LOG_IN" => "Log in",
    "WORDING_LOGOUT" => "Log out",
    "WORDING_NEW_EMAIL" => "New email",
    "WORDING_NEW_PASSWORD" => "New password",
    "WORDING_NEW_PASSWORD_REPEAT" => "Repeat new password",
    "WORDING_NEW_USERNAME" => "New username (username cannot be empty and must be azAZ09 and 2-64 characters)",
    "WORDING_OLD_PASSWORD" => "Your OLD Password",
    "WORDING_PASSWORD" => "Password",
    "WORDING_PROFILE_PICTURE" => "Your profile picture (from gravatar):",
    "WORDING_REGISTER" => "Register",
    "WORDING_REGISTER_NEW_ACCOUNT" => "Register new account",
    "WORDING_REGISTRATION_CAPTCHA" => "Please enter these characters",
    "WORDING_REGISTRATION_EMAIL" => "Your e-mail (please provide a real email address, you'll get a verification mail with an activation link)",
    "WORDING_REGISTRATION_PASSWORD" => "Password (min. 6 characters!)",
    "WORDING_REGISTRATION_PASSWORD_REPEAT" => "Password repeat",
    "WORDING_REGISTRATION_USERNAME" => "Username (only letters and numbers, 2 to 64 characters)",
    "WORDING_REMEMBER_ME" => "Keep me logged in (for 2 weeks)",
    "WORDING_REQUEST_PASSWORD_RESET" => "Request a password reset. Enter your username and you'll get a mail with instructions:",
    "WORDING_RESET_PASSWORD" => "Reset my password",
    "WORDING_SUBMIT_NEW_PASSWORD" => "Submit new password",
    "WORDING_USERNAME" => "Username",
    "WORDING_YOU_ARE_LOGGED_IN_AS" => "You are logged in as ",

    "WORDING_ALL_POSTS" => "All posts",
    "WORDING_ALL_COMMENTS" => "All comments",
    "WORDING_ADD_NEW" => "Add new",
    "WORDING_PUBLISHED" => "Published",
    "WORDING_UNPUBLISHED" => "Unpublished",
    "WORDING_EDIT" => "Edit",
    "WORDING_VIEW" => "View",
    "WORDING_DELETE" => "Delete",
    "WORDING_CATEGORIES" => "Categories",
    "WORDING_TAGS" => "Tags",
    "WORDING_ALL_CATEGORIES" => "All categories",
    "WORDING_CATEGORY" => "Category",
    "WORDING_ADD_NEW_CATEGORY" => "Add new category",
    "WORDING_ADD_NEW_COMMENT" => "Add new comment",
    "WORDING_COMMENTS" => "Comments",
    "WORDING_COMMENT" => "Comment",
    "WORDING_PRODUCTS" => "Products",
    "WORDING_ALL_PRODUCTS" => "All products",
    "WORDING_CATALOGUE" => "Catalogue",
    "WORDING_ALL_CATALOGUE" => "All catalogue",
    "WORDING_MANUFACTURER" => "Manufacturer",
    "WORDING_ALL_MANUFACTURER" => "All manufacturer",
    "WORDING_ADD_NEW_MANUFACTURER" => "Add new manufacturer",
    "WORDING_EDIT_MANUFACTURER" => "Edit manufacturer",
    "WORDING_SEARCH_MANUFACTURER" => "Search manufacturer",
    "WORDING_PAGES" => "Pages",
    "WORDING_PAGE_NAME" => "Page name",
    "WORDING_ALL_PAGES" => "All pages",
    "WORDING_MEDIA" => "Media",
    "WORDING_EDIT_MEDIA" => "Edit media",
    "WORDING_ADD_NEW_MEDIA" => "Add new media",
    "WORDING_LIBRARY" => "Library",
    "WORDING_APPEARANCE" => "Appearance",
    "WORDING_MENU" => "Menu",

    "WORDING_SETTINGS" => "Settings",
    "WORDING_GENERAL" => "General",
    "WORDING_CONTACT" => "Contact",
    "WORDING_LANGUAGES" => "Languages",
    "WORDING_SEO" => "SEO",
    "WORDING_OPTIMIZATION" => "Optimization",
    "WORDING_NEWSLETTER" => "Newsletter",
    "WORDING_USERS" => "Users",
    "WORDING_ALL_USERS" => "All users",

    "WORDING_HELP" => "Help",
    "WORDING_SAVE" => "Save",
    "WORDING_DIMENSION" => "Dimension",
    "WORDING_FILE_SIZE" => "File size",
    "WORDING_FILE_TYPE" => "File type",
    "WORDING_FILE_NAME" => "File name",
    "WORDING_FILE_URL" => "File URL",
    "WORDING_DELETE_PERMANENTLY" => "Delete permanently",
    "WORDING_UPLOADED_ON" => "Uploaded on",
    "WORDING_NO_UPLOADS" => "No uploads",
    "WORDING_DRAFT" => "Draft",
    "WORDING_TRASH" => "Trash",
    "WORDING_VISIBILITY" => "Visibility",
    "WORDING_PUBLIC" => "Public",
    "WORDING_PRIVATE" => "Private",
    "WORDING_PASSWORD_PROTECTED" => "Password protected",
    "WORDING_SERBIAN" => "Serbian",
    "WORDING_ENGLISH" => "English",
    "WORDING_LANGUAGE" => "Language",
    "WORDING_PUBLISH" => "Publish",
    "WORDING_ADD" => "Add",
    "WORDING_HUGE" => "Huge",
    "WORDING_NORMAL" => "Normal",
    "WORDING_SMALL" => "Small",
    "WORDING_SUBMIT" => "Submit",
    
    /*Pages*/
    "WORDING_ADD_NEW_CATALOGUE" => "Add new catalogue",
    "WORDING_EDIT_CATALOGUE" => "Edit catalogue",
    "WORDING_UPLOAD_FILE" => "Upload file",
    "WORDING_GO" => "Go!",
    "WORDING_AUTHOR" => "Author",
    "WORDING_STATUS" => "Status",
    "WORDING_CREATED" => "Created",
    "WORDING_EDIT" => "Edit",
    "WORDING_PAGE_EDIT" => "Page edit",
    "WORDING_CHOOSE_LANGUAGE" => "Choose language",
    "WORDING_DESCRIPTION" => "Description",
    "WORDING_FEATURED_IMAGE" => "Featured image",
    "WORDING_ALLREADY_A_MEMBER" => "Already a member",
    "WORDING_NEW_TO_SITE" => "New to site",
    "WORDING_LOGIN_FORM" => "Login form",
    "WORDING_LOST_YOUR_PASSWORD" => "Lost your password",
    "WORDING_PERMALINK" => "Permalink",
    "WORDING_EDIT_IMAGE" => "Edit image",
    "WORDING_CAPTION" => "Caption",
    "WORDING_ALTERNATIVE_TEXT" => "Alternative text",
    "WORDING_ALL_MEDIA_ITEMS" => "All media items",
    "WORDING_IMAGES" => "Images",
    "WORDING_AUDIO" => "Audio",
    "WORDING_VIDEO" => "Video",
    "WORDING_MENU_STRUCTURE" => "Menu structure",
    "WORDING_AVAILABLE_PAGES" => "Available pages",
    "WORDING_EDIT_MENU" => "Edit menu",
    "WORDING_SEARCH" => "Search",
    "WORDING_REPORT_THIS" => "Report this",
    "WORDING_SORRY" => "Sorry but we couldn't find this page",
    "WORDING_PAGE_PROBLEM" => "This page you are looking for does not exist",
    "WORDING_ADD_NEW_PAGE" => "Add new page",
    "WORDING_ENTER_TITLE" => "Enter title here",
    "WORDING_TITLE" => "Title",
    "WORDING_KEYWORDS" => "Keywords",
    "WORDING_IMAGE_LINK" => "Image link",
    "WORDING_FOLLOW_NO_FOLLOW" => "Follow / No folLow",
    "WORDING_FOLLOW" => "Follow",
    "WORDING_NO_FOLLOW" => "No follow",
    "WORDING_CANONICAL_URL" => "Canonical URL",
    "WORDING_EDIT_PAGE" => "Edit page",
    "WORDING_SEARCH_PAGES" => "Search pages",
    "WORDING_ALL" => "All",
    "WORDING_ADD_NEW_POST" => "Add new post",
    "WORDING_EDIT_POST" => "Edit post",
    "WORDING_SEARCH_POSTS" => "Search posts",
    "WORDING_ADD_NEW_PRODUCT" => "Add new product",
    "WORDING_PRODUCT_SPECIFICATION" => "Product specification",
    "WORDING_CATALOGUE_NUMBER" => "Catalogue number",
    "WORDING_SEARCH_CATEGORIES" => "Search categories",
    "WORDING_NAME" => "Name",
    "WORDING_PARENT" => "Parent",
    "WORDING_NAME_SUBTITLE" => "This name is how it appears on your site",
    "WORDING_PARENT_SUBTITLE" => "Categories, unlike tags, can have a hierarchy. You might have a Jazz category, and under that have children categories for Bebop and Big Band. Totally optional.",
    "WORDING_EDIT_PRODUCT" => "Edit product",
    "WORDING_SEARCH_PRODUCTS" => "Search products",
    "WORDING_ADRESS" => "Adress",
    "WORDING_CITY" => "City",
    "WORDING_COUNTRY" => "Country",
    "WORDING_POSTAL_CODE" => "Postal code",
    "WORDING_COORDINATES" => "Coordinates",
    "WORDING_PHONE_NUMBERS" => "Phone numbers",
    "WORDING_CONTACT_SETTINGS" => "Cotnact settings",
    "WORDING_NEWSLETTER_SETTINGS" => "Newsletter settings",
    "WORDING_GENERAL_SETTINGS" => "General settings",
    "WORDING_SITE_TITLE" => "Site title",
    "WORDING_DOMAIN_NAME" => "Domain name",
    "WORDING_LANGUAGE_SETTINGS" => "Language settings",
    "WORDING_SEO_SETTINGS" => "SEO settings",
    "WORDING_OPTIMIZATION_SETTINGS" => "Optimization settings",
    "WORDING_YES" => "Yes",
    "WORDING_NO" => "No",
    "WORDING_CASHING" => "Cashing",
    "WORDING_CASHING_TIME" => "Cashing time",
    "WORDING_CLEAR_CASHE" => "Clear cashe",
    "WORDING_CLEAR" => "Clear",
    "WORDING_FULL_NAME" => "Full name",
    "WORDING_PASSWORD" => "Password",
    "WORDING_WEBSITE" => "Website",
    "WORDING_ABOUT_USER" => "About",
    "WORDING_ROLE" => "Role",
    "WORDING_ADMINISTRATOR" => "Adminstrator",
    "WORDING_SUBSCRIBER" => "Subscriber",
    "WORDING_CUSTOMER" => "Customer",
    "WORDING_CONTRIBUTOR" => "Contributor",
    "WORDING_EDITOR" => "Editor",
    "WORDING_ADD_NEW_USER" => "Add new user",
    "WORDING_EDIT_USER" => "Edit user",
    "WORDING_USERS" => "Users",
    "WORDING_SEARCH_USERS" => "Search users",
    "WORDING_ALL_USERS" => "All users",
    "WORDING_PUBLISHED_ON" => "Published on",
    "WORDING_EDIT_CATALOGUE" => "Edit catalogue",

    'login_failed' => 'Login failed. Please try again.',
   

    
    
);
